Debian Bug report logs - #165358
libc6 2.3.1-1 breaks fetchmail/exim (and others?)

version graph

Package: libc6; Maintainer for libc6 is GNU Libc Maintainers <debian-glibc@lists.debian.org>; Source for libc6 is src:eglibc.

Reported by: Rene Engelhard <rene@debian.org>

Date: Fri, 18 Oct 2002 14:03:06 UTC

Severity: critical

Found in versions 2.3.1-1, 2.2.5-13, 2.3.1-2, 2.3.1-3

Fixed in version glibc/2.3.1-6

Done: Jeff Bailey <jbailey@nisa.net>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Rene Engelhard <rene@debian.org>:
New Bug report received and forwarded. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Rene Engelhard <rene@debian.org>
To: submit@bugs.debian.org
Subject: libc6 2.3.1-1 breaks fetchmail/exim (and others?)
Date: Fri, 18 Oct 2002 15:57:38 +0200
Package: libc6
Version: 2.3.1-1
Severity: critical
Justification: breaks unrelated software

Hi,

I yesterday upgraded glibc to the 2.3.1-1 release and suddenly my
fetchmail does not work complaining it cannot connect to local SMTP.

Downgrading all *libc* and locales Packages to 2.2.5-15 fixes that...

Sid, i386

Regards,

Rene
-- 
  .''`. Rene Engelhard -- Debian GNU/Linux Developer             
 : :' : http://www.debian.org | http://people.debian.org/~rene/ 
 `. `'  rene@debian.org | GnuPG-Key ID: 248AEB73
   `-   Fingerprint: 41FA F208 28D4 7CA5 19BB  7AD9 F859 90B0 248A EB73



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Vincenzo Gervasi <gervasi@di.unipi.it>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #10 received at 165358@bugs.debian.org (full text, mbox):

From: Vincenzo Gervasi <gervasi@di.unipi.it>
To: 165358@bugs.debian.org
Subject: A few more details on libc6 2.3.1-1 breakage
Date: 18 Oct 2002 18:13:28 +0200
The update broke other packages as well.
For example, java reports


Error occurred during initialization of VM
Unable to load native library:
/usr/java/j2sdk1.4.0/jre/lib/i386/libjava.so: symbol __libc_waitpid,
version GLIBC_2.0 not defined in file libc.so.6 with link time reference

I am not sure whether waitpid is the only call affected or not. In the
various changelogs for libc6 there is no mention of changes affecting
that particular call.

-Vincenzo




Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to GOTO Masanori <gotom@debian.or.jp>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #15 received at 165358@bugs.debian.org (full text, mbox):

From: GOTO Masanori <gotom@debian.or.jp>
To: Rene Engelhard <rene@debian.org>, 165358@bugs.debian.org
Subject: Re: Bug#165358: libc6 2.3.1-1 breaks fetchmail/exim (and others?)
Date: Sat, 19 Oct 2002 01:53:37 +0900
At Fri, 18 Oct 2002 15:57:38 +0200,
Rene Engelhard wrote:
> I yesterday upgraded glibc to the 2.3.1-1 release and suddenly my
> fetchmail does not work complaining it cannot connect to local SMTP.
> 
> Downgrading all *libc* and locales Packages to 2.2.5-15 fixes that...

/etc/init.d/nscd stop
/etc/init.d/nscd start

-- gotom



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #20 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Rene Engelhard <rene@debian.org>, 165358@bugs.debian.org
Subject: Re: Bug#165358: libc6 2.3.1-1 breaks fetchmail/exim (and others?)
Date: Fri, 18 Oct 2002 10:02:21 -0700
On Fri, Oct 18, 2002 at 03:57:38PM +0200, Rene Engelhard wrote:

> I yesterday upgraded glibc to the 2.3.1-1 release and suddenly my
> fetchmail does not work complaining it cannot connect to local SMTP.

> Downgrading all *libc* and locales Packages to 2.2.5-15 fixes that...

2.3.1-2 will have a warning saying that you need to restart all
NSS-using services.  After you upgrade, restart your local SMTP
service, and you'll be fine.

-- 
learning from failures is nice in theory...
but in practice, it sucks :)
 - Wolfgang Jaehrling



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #25 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Vincenzo Gervasi <gervasi@di.unipi.it>, 165358@bugs.debian.org
Subject: Re: Bug#165358: A few more details on libc6 2.3.1-1 breakage
Date: Fri, 18 Oct 2002 10:03:49 -0700
On Fri, Oct 18, 2002 at 06:13:28PM +0200, Vincenzo Gervasi wrote:
> 
> The update broke other packages as well.
> For example, java reports

> Error occurred during initialization of VM
> Unable to load native library:
> /usr/java/j2sdk1.4.0/jre/lib/i386/libjava.so: symbol __libc_waitpid,
> version GLIBC_2.0 not defined in file libc.so.6 with link time reference

> I am not sure whether waitpid is the only call affected or not. In the
> various changelogs for libc6 there is no mention of changes affecting
> that particular call.

The trick here is that they're not calling waitpid, they're calling
__libc_waitpid, which is not a published call.  All internal
interfaces are now hiden from user applications, and any applications
which used them (despite the fact that they were undocumented and
didn't appear in headers) will now break.

Newer versions of the jdk fix this bug.

-- 
learning from failures is nice in theory...
but in practice, it sucks :)
 - Wolfgang Jaehrling



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #30 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: 165358@bugs.debian.org
Subject: Also caused segfaults in su and ssh
Date: Fri, 18 Oct 2002 13:37:51 -0500
[Message part 1 (text/plain, inline)]
Attempting to su to root (even from root) with 2.3.1-1 on one of my
test systems caused an immediate segfault.  Also, attempting to ssh to
root on the same system allowed login, but then immediately died.  The
problem was fixed by reverting libc6 and related package.  No core
files were left, but if it's important, I can probably be persuaded to
put the broken libc6 version back on and run su inside of gdb.

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #35 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Zed Pobre <zed@resonant.org>, 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Fri, 18 Oct 2002 12:09:14 -0700
On Fri, Oct 18, 2002 at 01:37:51PM -0500, Zed Pobre wrote:

> Attempting to su to root (even from root) with 2.3.1-1 on one of my
> test systems caused an immediate segfault.  Also, attempting to ssh
> to root on the same system allowed login, but then immediately died.
> The problem was fixed by reverting libc6 and related package.  No
> core files were left, but if it's important, I can probably be
> persuaded to put the broken libc6 version back on and run su inside
> of gdb.

The ssh problem is probably the known bug that anything using NSS
needs to be restarted after the libc upgrade.  The next package will
warn about that.

I've been using test versions of the 2.3 package for almost a month
now and haven't seen any su segfaults.  Please investigate that
further.


-- 
learning from failures is nice in theory...
but in practice, it sucks :)
 - Wolfgang Jaehrling



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #40 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Fri, 18 Oct 2002 15:01:17 -0500
[Message part 1 (text/plain, inline)]
On Fri, Oct 18, 2002 at 12:09:14PM -0700, Jeff Bailey wrote:
> On Fri, Oct 18, 2002 at 01:37:51PM -0500, Zed Pobre wrote:
> 
> > Attempting to su to root (even from root) with 2.3.1-1 on one of my
> > test systems caused an immediate segfault.  Also, attempting to ssh
> > to root on the same system allowed login, but then immediately died.
> > The problem was fixed by reverting libc6 and related package.  No
> > core files were left, but if it's important, I can probably be
> > persuaded to put the broken libc6 version back on and run su inside
> > of gdb.
> 
> The ssh problem is probably the known bug that anything using NSS
> needs to be restarted after the libc upgrade.  The next package will
> warn about that.
> 
> I've been using test versions of the 2.3 package for almost a month
> now and haven't seen any su segfaults.  Please investigate that
> further.

    I'm admittedly not that experienced at this sort of thing, but
this is bizarre:

shannon:~# gdb su
GNU gdb 2002-08-18-cvs
Copyright 2002 Free Software Foundation, Inc.
GDB is free software, covered by the GNU General Public License, and you are
welcome to change it and/or distribute copies of it under certain conditions.
Type "show copying" to see the conditions.
There is absolutely no warranty for GDB.  Type "show warranty" for details.
This GDB was configured as "i386-linux"...(no debugging symbols found)...
(gdb) run
Starting program: /bin/su 
(no debugging symbols found)...(no debugging symbols found)...(no debugging symbols found)...(no debugging symbols found)...
(no debugging symbols found)...(no debugging symbols found)...(no debugging symbols found)...(no debugging symbols found)...
(no debugging symbols found)...(no debugging symbols found)...(no debugging symbols found)...(no debugging symbols found)...
Program received signal SIGTRAP, Trace/breakpoint trap.
Cannot remove breakpoints because program is no longer writable.
It might be running in another process.
Further execution is probably impossible.
0x080480e0 in ?? ()
(gdb) backtrace
#0  0x080480e0 in ?? ()
Cannot access memory at address 0x0
(gdb) 


This make any sense to you?  Should I play around with recompiling su?

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Ed Tomlinson <tomlins@cam.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #45 received at 165358@bugs.debian.org (full text, mbox):

From: Ed Tomlinson <tomlins@cam.org>
To: 165358@bugs.debian.org
Subject: smtp problems after update _and_ reboot
Date: Sat, 19 Oct 2002 10:28:02 -0400
Hi,

I use postfix for local smtp.  After upgrading kmail had trouble talking to it. 
I then rebooted to ensure that all progs (at least those non static) were using
the new libc.  There were still problems with smtp...  Also my squid proxy was
refusing connections...

Think there is more to this problem that restarting apps (reverting to 2.2.5-15
fixes things)

Ed Tomlinson



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Justus Schwartz <hekacyr@web.de>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #50 received at 165358@bugs.debian.org (full text, mbox):

From: Justus Schwartz <hekacyr@web.de>
To: 165358@bugs.debian.org
Subject: libc6 breaks static linked glftpd
Date: Sat, 19 Oct 2002 18:05:16 +0200
hi!

my xmms stopped working (sigseg) after the libc6 update, but i think thats the
known glib problem.

glpftd (as binary installed from www.glftpd.org) doesn't work anymore too. it's a
static linked binary, so i am really surprised. (its definitely the libc6
because it immediatly starts working again, if i downgrade to 2.2.5)

i don't know how to provide more usefull information as it is statically linked
and started from xinetd (which i restarted and i even rebooted my machine)

ciao
  -justus



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jean-Luc Coulon <jean-luc.coulon@wanadoo.fr>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org.

Your message did not contain a Subject field. They are recommended and useful because the title of a Bug is determined using this field. Please remember to include a Subject field in your messages in future.

Full text and rfc822 format available.


Message #55 received at 165358@bugs.debian.org (full text, mbox):

From: Jean-Luc Coulon <jean-luc.coulon@wanadoo.fr>
To: Debian Bug Tracking System <165358@bugs.debian.org>
Date: Sat, 19 Oct 2002 19:31:45 +0200
Package: libc6
Version: 2.2.5-13
Followup-For: Bug #165358

Hi,

with the new version of libc, I have :
1) htmerge (part of htdig package) that eats all of the memory and all
of the swap then the system begin killing tasks.

2) ppp
During the whole ppp session I get the following messages :
Oct 19 17:12:29 f5ibh modprobe: modprobe: Can't locate module 
Oct 19 17:13:00 f5ibh last message repeated 772 times
Oct 19 17:14:01 f5ibh last message repeated 1526 times
Oct 19 17:15:02 f5ibh last message repeated 1608 times
Oct 19 17:16:02 f5ibh last message repeated 1573 times
Oct 19 17:17:04 f5ibh last message repeated 1554 times
Oct 19 17:18:05 f5ibh last message repeated 1562 times

without any module name.

Back to 2.2.5-13 and all is fine.

------
Regards
	Jean-Luc


-- System Information:
Debian Release: testing/unstable
Architecture: i386
Kernel: Linux debian-f5ibh 2.4.20-pre11 #1 mer oct 16 09:41:04 CEST 2002 i586
Locale: LANG=fr_FR@euro, LC_CTYPE=ISO-8859-15 (ignored: LC_ALL set)

-- no debconf information


Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #60 received at 165358@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Justus Schwartz <hekacyr@web.de>, 165358@bugs.debian.org
Subject: Re: Bug#165358: libc6 breaks static linked glftpd
Date: Sat, 19 Oct 2002 15:14:41 -0400
On Sat, Oct 19, 2002 at 06:05:16PM +0200, Justus Schwartz wrote:
> hi!
> 
> my xmms stopped working (sigseg) after the libc6 update, but i think thats the
> known glib problem.
> 
> glpftd (as binary installed from www.glftpd.org) doesn't work anymore too. it's a
> static linked binary, so i am really surprised. (its definitely the libc6
> because it immediatly starts working again, if i downgrade to 2.2.5)
> 
> i don't know how to provide more usefull information as it is statically linked
> and started from xinetd (which i restarted and i even rebooted my machine)

Static binaries tend to break when you update glibc.  That's a sad fact
of life... they don't provide compatibility for NSS modules.

Not sure we can do anything about this.

-- 
Daniel Jacobowitz
MontaVista Software                         Debian GNU/Linux Developer



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Anthony DeRobertis <asd@suespammers.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #65 received at 165358@bugs.debian.org (full text, mbox):

From: Anthony DeRobertis <asd@suespammers.org>
To: Justus Schwartz <hekacyr@web.de>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: libc6 breaks static linked glftpd
Date: 19 Oct 2002 16:07:06 -0400
[Message part 1 (text/plain, inline)]
On Sat, 2002-10-19 at 12:05, Justus Schwartz wrote:

> glpftd (as binary installed from www.glftpd.org) doesn't work anymore too. it's a
> static linked binary, so i am really surprised. (its definitely the libc6
> because it immediatly starts working again, if i downgrade to 2.2.5)

ldd /path/to/glftpd

Is it really linked statically?
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Justus Schwartz <hekacyr@web.de>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #70 received at 165358@bugs.debian.org (full text, mbox):

From: Justus Schwartz <hekacyr@web.de>
To: 165358@bugs.debian.org
Cc: Anthony DeRobertis <asd@suespammers.org>
Subject: Re: Bug#165358: libc6 breaks static linked glftpd
Date: Sun, 20 Oct 2002 01:33:57 +0200
* Anthony DeRobertis <asd@suespammers.org> [021019 22:07]:
> On Sat, 2002-10-19 at 12:05, Justus Schwartz wrote:

> > static linked binary, so i am really surprised. (its definitely the libc6
> > because it immediatly starts working again, if i downgrade to 2.2.5)
>
> ldd /path/to/glftpd
>
> Is it really linked statically?

yes it is (not a dynamic executable). i found a strange proposal on the
glftpd.com how to fix it for glfptd for the moment (replace all occurences of
nss/libn with something else *g*) .

but i hope, they will provide new binaries.

so i learned it's the problem with the nss modules, and not a libc bug. having
still some trouble ;)

so long
  -justus



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to GOTO Masanori <gotom@debian.or.jp>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #75 received at 165358@bugs.debian.org (full text, mbox):

From: GOTO Masanori <gotom@debian.or.jp>
To: Daniel Jacobowitz <dan@debian.org>, 165358@bugs.debian.org
Cc: Justus Schwartz <hekacyr@web.de>
Subject: Re: Bug#165358: libc6 breaks static linked glftpd
Date: Sun, 20 Oct 2002 12:43:17 +0900
At Sat, 19 Oct 2002 15:14:41 -0400,
Daniel Jacobowitz wrote:
> On Sat, Oct 19, 2002 at 06:05:16PM +0200, Justus Schwartz wrote:
> > my xmms stopped working (sigseg) after the libc6 update, but i think thats the
> > known glib problem.
> > 
> > glpftd (as binary installed from www.glftpd.org) doesn't work anymore too. it's a
> > static linked binary, so i am really surprised. (its definitely the libc6
> > because it immediatly starts working again, if i downgrade to 2.2.5)
> > 
> > i don't know how to provide more usefull information as it is statically linked
> > and started from xinetd (which i restarted and i even rebooted my machine)
> 
> Static binaries tend to break when you update glibc.  That's a sad fact
> of life... they don't provide compatibility for NSS modules.
> 
> Not sure we can do anything about this.

Well, it's serious problem, many static linked binaries (compiled
before 2.3) get segv. I don't know how to fix.

IMHO, one way to fix it is bumping up glibc nss version, because
breaking ABI back compatibility always change its lib.so
version (Of course, it needs upstream decision). Thus,
libnss_files.so.3 -> libnss_files-2.3.1.so (Don't test unless you
know what is occured).

-- gotom




Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Josselin Mouette <joss@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #80 received at 165358@bugs.debian.org (full text, mbox):

From: Josselin Mouette <joss@debian.org>
To: Debian Bug Tracking System <165358@bugs.debian.org>
Subject: libc6: Breaks courier-imap as well
Date: Mon, 21 Oct 2002 20:19:05 +0200
Package: libc6
Version: 2.3.1-2
Followup-For: Bug #165358

It looks like the libc6 upgrade also breaks courier-imap, probably due =

to NSS problems. It looks like you just need to restart =

courier-authdaemon if it is running.

Greetings,
-- =

 .''`.           Josselin Mouette        /\./\
: :' :           josselin.mouette@ens-lyon.org
`. `'                        joss@debian.org
  `-  Debian GNU/Linux -- The power of freedom





Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Sebastien NOEL <twolife@altern.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #85 received at 165358@bugs.debian.org (full text, mbox):

From: Sebastien NOEL <twolife@altern.org>
To: Debian Bug Tracking System <165358@bugs.debian.org>
Subject: libc6: Breaks winex
Date: Mon, 21 Oct 2002 23:47:58 +0200
Package: libc6
Version: 2.3.1-2
Followup-For: Bug #165358

I notice that the libc6 upgrade also breaks winex (commercial version).

example :
twolife@omikron:~$ winex CALC.EXE =

/usr/lib/transgaming/winex/bin/wine: relocation error:
/usr/lib/transgaming/winex/lib/libntdll.so: symbol __libc_fork, version
GLIBC_2.1.2 not defined in file libc.so.6 with link time reference

Can you assure me that the problem comes from the package libc in not of
winex ?

Thank you

-- System Information:
Debian Release: testing/unstable
Architecture: i386
Kernel: Linux omikron 2.4.19 #1 sam sep 14 18:01:32 CEST 2002 i686
Locale: LANG=3Dfr_BE@euro, LC_CTYPE=3Dfr_BE@euro

Versions of packages libc6 depends on:
ii  libdb1-compat                 2.1.3-7    The Berkeley database routines=
 [gl

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Marcus Crafter <crafterm@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #90 received at 165358@bugs.debian.org (full text, mbox):

From: Marcus Crafter <crafterm@debian.org>
To: Debian Bug Tracking System <165358@bugs.debian.org>
Subject: libc6: j2sdk 1.4.1 works with updated libc6
Date: Tue, 22 Oct 2002 16:11:43 +0200
Package: libc6
Version: 2.3.1-3
Followup-For: Bug #165358

Hi There,

>The trick here is that they're not calling waitpid, they're calling
>__libc_waitpid, which is not a published call.  All internal
>interfaces are now hiden from user applications, and any applications
>which used them (despite the fact that they were undocumented and
>didn't appear in headers) will now break.
>
>Newer versions of the jdk fix this bug.

	I can confirm that the latest jdk 1.4.1 package from Sun works fine
	with the latest libc6 packages:
	=

fztig938[/home/crafterm]:81>java -version
java version "1.4.1_01"
Java(TM) 2 Runtime Environment, Standard Edition (build 1.4.1_01-b01)
Java HotSpot(TM) Client VM (build 1.4.1_01-b01, mixed mode)

	Cheers,
	=

	Marcus

-- System Information:
Debian Release: testing/unstable
Architecture: i386
Kernel: Linux fztig938 2.4.17 #1 Fri Mar 1 17:49:21 CET 2002 i686
Locale: LANG=3DC, LC_CTYPE=3DC (ignored: LC_ALL set)

Versions of packages libc6 depends on:
ii  libdb1-compat                 2.1.3-7    The Berkeley database routines=
 [gl

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #95 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Tue, 22 Oct 2002 12:43:16 -0500
[Message part 1 (text/plain, inline)]
On Fri, Oct 18, 2002 at 12:09:14PM -0700, Jeff Bailey wrote:
> On Fri, Oct 18, 2002 at 01:37:51PM -0500, Zed Pobre wrote:
> 
> > Attempting to su to root (even from root) with 2.3.1-1 on one of my
> > test systems caused an immediate segfault.  Also, attempting to ssh
> 
> The ssh problem is probably the known bug that anything using NSS
> needs to be restarted after the libc upgrade.  The next package will
> warn about that.
> 
> I've been using test versions of the 2.3 package for almost a month
> now and haven't seen any su segfaults.  Please investigate that
> further.

    The problem was that root uses zsh-static as a shell, and static
libraries got broken by this (a bug has already been filed on
zsh-static about this).  Should it be the responsibility of all
packages containing statically compiled binaries to declare an
explicit dependency on the version of libc used to compile them?  This
*really badly damaged* a few systems using static binaries out here
when I forgot that I'd manually moved their libcs out of stable and
into testing some time back and never put them on hold for a mass
upgrade of stable/security packages...  (yeah, yeah, my fault for not
paying attention, but this wasn't the kind of thing I expected to get
hit by).

    I also have to add that I find this to be completely contradictory
behaviour to how I expect static binaries to behave.  I compile things
statically when I want them to work properly no matter what version of
various libraries are on the system.  If they're not going to work
correctly without a particular version of libc6, might as well stop
providing libc.a and force everything to acknowledge the fact that
they're tied to the system libc.  

    Okay, the above is inflammatory, and I've debated deleting it with
myself for a little while, but I'm going to let it stand, because some
upgrade path is going to have to be provided by the next release --
and certainly neither this libc6, nor anything compiled against it,
should go into testing until some mechanism is found to prevent
someone running woody with a statically linked shell from apt-get
installing something compiled against the new libc6 and finding
himself unable to log in afterwards to fix all the things that
suddenly broke.  Possibly this could be handled by putting new
versions of busybox-static, sash, zsh-static, kiss, and e2fsck-static
(do we ship any other statically linked admin tools?) into woody that
conflict the newer version of libc6, and adding to policy that future
packages that ship statically compiled binaries have to conflict with
any libc6 with a larger minor number than the one used to compile
them, but I truly think there should be a better answer.  Is there no
way to get the code of whatever is breaking to be included in a
statically compiled binary, so this doesn't happen again in the
future?


> learning from failures is nice in theory...
> but in practice, it sucks :)
>  - Wolfgang Jaehrling

    Indeed.

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #100 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Zed Pobre <zed@resonant.org>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Tue, 22 Oct 2002 11:08:09 -0700
On Tue, Oct 22, 2002 at 12:43:16PM -0500, Zed Pobre wrote:

>     Okay, the above is inflammatory, and I've debated deleting it
> with myself for a little while, but I'm going to let it stand,
> because some upgrade path is going to have to be provided by the
> next release --

Sadly, your rant is too late.  =) 2.3.1-3 provides an upgrade path by
providing compatability with old static binaries.  They will break at
some point in the future, but any static binaries/libraries compiled
against 2.3 will continue to be fine.

If you have any further problems, please let us know.

Tks,
Jeff Bailey

-- 
learning from failures is nice in theory...
but in practice, it sucks :)
 - Wolfgang Jaehrling



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #105 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Tue, 22 Oct 2002 17:49:46 -0500
[Message part 1 (text/plain, inline)]
On Tue, Oct 22, 2002 at 11:08:09AM -0700, Jeff Bailey wrote:
> On Tue, Oct 22, 2002 at 12:43:16PM -0500, Zed Pobre wrote:
> 
> >     Okay, the above is inflammatory, and I've debated deleting it
> > with myself for a little while, but I'm going to let it stand,
> > because some upgrade path is going to have to be provided by the
> > next release --
> 
> Sadly, your rant is too late.  =) 2.3.1-3 provides an upgrade path by
> providing compatability with old static binaries.  They will break at
> some point in the future, but any static binaries/libraries compiled
> against 2.3 will continue to be fine.

    I am confused.  I can confirm that it is *not* true that static
binaries compiled against 2.2 (i.e. woody libc6) will function with
2.3.1-3, and I'm more concerned about that than I am about doing this
all over again in the future (i.e. until this is resolved, there will
be no clean way to handle a partial upgrade from woody to sarge).  But
just so I get this right, it is now true that anything compiled
statically against 2.3.1-3+ should work even on a future system
running libc6, say, 4.5.9?

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #110 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Zed Pobre <zed@resonant.org>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Tue, 22 Oct 2002 15:53:37 -0700
On Tue, Oct 22, 2002 at 05:49:46PM -0500, Zed Pobre wrote:

> > >     Okay, the above is inflammatory, and I've debated deleting
> > > it with myself for a little while, but I'm going to let it
> > > stand, because some upgrade path is going to have to be provided
> > > by the next release --

> > Sadly, your rant is too late.  =) 2.3.1-3 provides an upgrade path
> > by providing compatability with old static binaries.  They will
> > break at some point in the future, but any static
> > binaries/libraries compiled against 2.3 will continue to be fine.

>     I am confused.  I can confirm that it is *not* true that static
> binaries compiled against 2.2 (i.e. woody libc6) will function with
> 2.3.1-3, 

Hmm.  I'll need a testcase then, because the testcases we have now
work.

> and I'm more concerned about that than I am about doing this all
> over again in the future (i.e. until this is resolved, there will be
> no clean way to handle a partial upgrade from woody to sarge).  But
> just so I get this right, it is now true that anything compiled
> statically against 2.3.1-3+ should work even on a future system
> running libc6, say, 4.5.9?

I can't promise you a length of time in the future.  The problem is
that statically linked binaries on systems using glibc (So, GNU/Linux,
GNU/Hurd, GNU/FreeBSD) are not entirely statically linked.  They still
reference NSS DSO's.  There's no promise of infinite forward
compatability.

Tks,
Jeff Bailey

-- 
learning from failures is nice in theory...
but in practice, it sucks :)
 - Wolfgang Jaehrling



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Lukas Hejtmanek <xhejtman@mail.muni.cz>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #115 received at 165358@bugs.debian.org (full text, mbox):

From: Lukas Hejtmanek <xhejtman@mail.muni.cz>
To: 165358@bugs.debian.org
Subject: CADP tool crash
Date: Wed, 23 Oct 2002 16:35:55 +0200
I have cadp tool, that is also statically linked. It crashes on sig segv.
Strace shows that it crashes after it open and mmap /lib/ld_linux.so

open("/lib/ld-linux.so.2", O_RDONLY)    = 5
fstat(5, {st_mode=S_IFREG|0755, st_size=83504, ...}) = 0
read(5, "\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0P\v\0\000"..., 4096) = 4
096
brk(0x80f0000)                          = 0x80f0000
old_mmap(NULL, 71424, PROT_READ|PROT_EXEC, MAP_PRIVATE, 5, 0) = 0x4012b000
mprotect(0x4013c000, 1792, PROT_NONE)   = 0
old_mmap(0x4013c000,4096,PROT_READ|PROT_WRITE,MAP_PRIVATE|MAP_FIXED, 5, 0x11000)
= 0x4013c000
close(5)                                = 0
--- SIGSEGV (Segmentation fault) ---
+++ killed by SIGSEGV +++

when it does not crash (with libc 2.2.5) it do munmap after close(5).
I do not have source codes.

Program is statically linked but after start it open its binary then open
libnss_files, libc and ld-linux.so.

-- 
Lukáš Hejtmánek



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Lukas Hejtmanek <xhejtman@mail.muni.cz>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #120 received at 165358@bugs.debian.org (full text, mbox):

From: Lukas Hejtmanek <xhejtman@mail.muni.cz>
To: 165358@bugs.debian.org
Subject: CADP tool crash
Date: Wed, 23 Oct 2002 16:36:47 +0200
I forgot to say I'm using libc6 version 2.3.1-3

-- 
Lukáš Hejtmánek



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #125 received at 165358@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Lukas Hejtmanek <xhejtman@mail.muni.cz>, 165358@bugs.debian.org
Subject: Re: Bug#165358: CADP tool crash
Date: Wed, 23 Oct 2002 12:03:42 -0400
On Wed, Oct 23, 2002 at 04:35:55PM +0200, Lukas Hejtmanek wrote:
> 
> I have cadp tool, that is also statically linked. It crashes on sig segv.
> Strace shows that it crashes after it open and mmap /lib/ld_linux.so
> 
> open("/lib/ld-linux.so.2", O_RDONLY)    = 5
> fstat(5, {st_mode=S_IFREG|0755, st_size=83504, ...}) = 0
> read(5, "\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0P\v\0\000"..., 4096) = 4
> 096
> brk(0x80f0000)                          = 0x80f0000
> old_mmap(NULL, 71424, PROT_READ|PROT_EXEC, MAP_PRIVATE, 5, 0) = 0x4012b000
> mprotect(0x4013c000, 1792, PROT_NONE)   = 0
> old_mmap(0x4013c000,4096,PROT_READ|PROT_WRITE,MAP_PRIVATE|MAP_FIXED, 5, 0x11000)
> = 0x4013c000
> close(5)                                = 0
> --- SIGSEGV (Segmentation fault) ---
> +++ killed by SIGSEGV +++
> 
> when it does not crash (with libc 2.2.5) it do munmap after close(5).
> I do not have source codes.
> 
> Program is statically linked but after start it open its binary then open
> libnss_files, libc and ld-linux.so.

What version was it built with?

If it was 2.2.5, then 2.3.1-3 should have fixed this; not sure why it
didn't.

-- 
Daniel Jacobowitz
MontaVista Software                         Debian GNU/Linux Developer



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Lukas Hejtmanek <xhejtman@mail.muni.cz>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #130 received at 165358@bugs.debian.org (full text, mbox):

From: Lukas Hejtmanek <xhejtman@mail.muni.cz>
To: Daniel Jacobowitz <dan@debian.org>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: CADP tool crash
Date: Wed, 23 Oct 2002 18:06:46 +0200
On Wed, Oct 23, 2002 at 12:03:42PM -0400, Daniel Jacobowitz wrote:
> On Wed, Oct 23, 2002 at 04:35:55PM +0200, Lukas Hejtmanek wrote:
> > 
> > I have cadp tool, that is also statically linked. It crashes on sig segv.
> > Strace shows that it crashes after it open and mmap /lib/ld_linux.so
> > 
> > open("/lib/ld-linux.so.2", O_RDONLY)    = 5
> > fstat(5, {st_mode=S_IFREG|0755, st_size=83504, ...}) = 0
> > read(5, "\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0P\v\0\000"..., 4096) = 4
> > 096
> > brk(0x80f0000)                          = 0x80f0000
> > old_mmap(NULL, 71424, PROT_READ|PROT_EXEC, MAP_PRIVATE, 5, 0) = 0x4012b000
> > mprotect(0x4013c000, 1792, PROT_NONE)   = 0
> > old_mmap(0x4013c000,4096,PROT_READ|PROT_WRITE,MAP_PRIVATE|MAP_FIXED, 5, 0x11000)
> > = 0x4013c000
> > close(5)                                = 0
> > --- SIGSEGV (Segmentation fault) ---
> > +++ killed by SIGSEGV +++
> > 
> > when it does not crash (with libc 2.2.5) it do munmap after close(5).
> > I do not have source codes.
> > 
> > Program is statically linked but after start it open its binary then open
> > libnss_files, libc and ld-linux.so.
> 
> What version was it built with?
> 
> If it was 2.2.5, then 2.3.1-3 should have fixed this; not sure why it
> didn't.

I'm using 2.3.1-3. I do not know against which library it was build but with
2.2.5 it is working.

-- 
Lukáš Hejtmánek



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #135 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Wed, 23 Oct 2002 13:45:37 -0500
[Message part 1 (text/plain, inline)]
On Tue, Oct 22, 2002 at 03:53:37PM -0700, Jeff Bailey wrote:
> On Tue, Oct 22, 2002 at 05:49:46PM -0500, Zed Pobre wrote:
> > > Sadly, your rant is too late.  =) 2.3.1-3 provides an upgrade path
> > > by providing compatability with old static binaries.  They will
> > > break at some point in the future, but any static
> > > binaries/libraries compiled against 2.3 will continue to be fine.
> 
> >     I am confused.  I can confirm that it is *not* true that static
> > binaries compiled against 2.2 (i.e. woody libc6) will function with
> > 2.3.1-3, 
> 
> Hmm.  I'll need a testcase then, because the testcases we have now
> work.

    The two big ones here are Mathematica (sadly, I am going to be
unable to provide you with a copy of this, though I'll cheerfully run
experimental versions of libc to help test) and zsh-static.


> I can't promise you a length of time in the future.  The problem is
> that statically linked binaries on systems using glibc (So, GNU/Linux,
> GNU/Hurd, GNU/FreeBSD) are not entirely statically linked.  They still
> reference NSS DSO's.  There's no promise of infinite forward
> compatability.

    This is a major problem -- this means that producers of
binary-only software have no way of reliably producing a working
binary under an arbitrary Debian release (or, for that matter, under
any glibc-based distribution), and while I am somewhat sympathetic to
a viewpoint of not greatly supporting non-free software", I'm also in
a position of having to use and support a fair amount of it because
there is no free equivalent.  Is there any way to get the NSS code
also statically linked?  I have a memory of this not being a problem
at one point in the past.

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #140 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Zed Pobre <zed@resonant.org>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Wed, 23 Oct 2002 11:55:04 -0700
On Wed, Oct 23, 2002 at 01:45:37PM -0500, Zed Pobre wrote:

>     This is a major problem -- this means that producers of
> binary-only software have no way of reliably producing a working
> binary under an arbitrary Debian release (or, for that matter, under
> any glibc-based distribution), and while I am somewhat sympathetic
> to a viewpoint of not greatly supporting non-free software", I'm
> also in a position of having to use and support a fair amount of it
> because there is no free equivalent.  Is there any way to get the
> NSS code also statically linked?  I have a memory of this not being
> a problem at one point in the past.

Let's first take a look at what the problem is.  If you can reproduce
with zsh-static, then we have a hope of getting an answer for why -3
doesn't solve it in that case.

As far as long term support and static NSS, I would probably have to
refer you directly to upstream.  I don't have a good answer, but I
suspect it's just one of those platform quirks. =(

Tks,
Jeff Bailey

-- 
learning from failures is nice in theory...
but in practice, it sucks :)
 - Wolfgang Jaehrling



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #145 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: Also caused segfaults in su and ssh
Date: Wed, 23 Oct 2002 15:06:03 -0500
[Message part 1 (text/plain, inline)]
On Wed, Oct 23, 2002 at 11:55:04AM -0700, Jeff Bailey wrote:
> On Wed, Oct 23, 2002 at 01:45:37PM -0500, Zed Pobre wrote:
> 
> >     This is a major problem -- this means that producers of
> > binary-only software have no way of reliably producing a working
> > binary under an arbitrary Debian release (or, for that matter, under
> > any glibc-based distribution), and while I am somewhat sympathetic
> > to a viewpoint of not greatly supporting non-free software", I'm
> > also in a position of having to use and support a fair amount of it
> > because there is no free equivalent.  Is there any way to get the
> > NSS code also statically linked?  I have a memory of this not being
> > a problem at one point in the past.
> 
> Let's first take a look at what the problem is.  If you can reproduce
> with zsh-static, then we have a hope of getting an answer for why -3
> doesn't solve it in that case.

    Oh, I can trivially reproduce.  On any machine.  I'll probably
need to recompile zsh with debugging enabled to get useful results,
but here's an initial backtrace for you:

singularity:~> gdb zsh-static
GNU gdb 2002-08-18-cvs
Copyright 2002 Free Software Foundation, Inc.
GDB is free software, covered by the GNU General Public License, and you are
welcome to change it and/or distribute copies of it under certain conditions.
Type "show copying" to see the conditions.
There is absolutely no warranty for GDB.  Type "show warranty" for details.
This GDB was configured as "i386-linux"...(no debugging symbols found)...
(gdb) run
Starting program: /bin/zsh-static 
warning: shared library handler failed to enable breakpoint

Program received signal SIGSEGV, Segmentation fault.
0x08122ed3 in ?? ()
(gdb) backtrace
#0  0x08122ed3 in ?? ()
#1  0x0811cbeb in ?? ()
#2  0x0810b04e in ?? ()
#3  0x0811ce52 in ?? ()
#4  0x0810b9a8 in ?? ()
#5  0x0810b04e in ?? ()
#6  0x0810b963 in ?? ()
#7  0x0810ba18 in ?? ()
#8  0x08104775 in ?? ()
#9  0x08104470 in ?? ()
#10 0x081053dd in ?? ()
#11 0x081012bf in ?? ()
#12 0x08100eff in ?? ()
#13 0x08065f67 in ?? ()
#14 0x08067395 in ?? ()
#15 0x080481c8 in ?? ()
#16 0x080dee25 in ?? ()


This is with libc6 2.3.1-3 and zsh-static 4.0.6-13.  Let me know if
you want me to recompile libc6, zsh-static, or both, or if there's
anything more I can do to be helpful.


> As far as long term support and static NSS, I would probably have to
> refer you directly to upstream.  I don't have a good answer, but I
> suspect it's just one of those platform quirks. =(

    If it can't be fixed, then I actually go back to my recommendation
that we stop shipping libc.a, and recommend to upstream that they drop
support for libc.a, because it's basically a sham.

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #150 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: 165358@bugs.debian.org
Subject: apropos (from man-db) also apparently broken
Date: Mon, 28 Oct 2002 11:39:32 -0600
[Message part 1 (text/plain, inline)]
I'm also getting segfaults from apropos (from man-db 2.3.20-18) when
an argument is specified, but only with libc6 2.3.1-3 installed (it
works fine with 2.2.5-15).

Backtrace from coredump:

erdos:~> gdb /usr/bin/apropos core
gdb: Symbol `emacs_ctlx_keymap' has different size in shared object, consider re-linking
GNU gdb 2002-04-01-cvs
Copyright 2002 Free Software Foundation, Inc.
GDB is free software, covered by the GNU General Public License, and you are
welcome to change it and/or distribute copies of it under certain conditions.
Type "show copying" to see the conditions.
There is absolutely no warranty for GDB.  Type "show warranty" for details.
This GDB was configured as "i386-linux"...(no debugging symbols found)...
Core was generated by `apropos apropos'.
Program terminated with signal 11, Segmentation fault.
Reading symbols from /lib/libc.so.6...(no debugging symbols found)...done.
Loaded symbols for /lib/libc.so.6
Reading symbols from /lib/libdb2.so.2...(no debugging symbols found)...done.
Loaded symbols for /lib/libdb2.so.2
Reading symbols from /lib/ld-linux.so.2...(no debugging symbols found)...done.
Loaded symbols for /lib/ld-linux.so.2
#0  0x400c89e3 in re_exec () from /lib/libc.so.6
(gdb) backtrace
#0  0x400c89e3 in re_exec () from /lib/libc.so.6
#1  0x400c87c3 in re_exec () from /lib/libc.so.6
#2  0x400c3ae3 in re_exec () from /lib/libc.so.6
#3  0x400c31f2 in regexec () from /lib/libc.so.6
#4  0x080497a2 in strcpy ()
#5  0x08049903 in strcpy ()
#6  0x08049c05 in strcpy ()
#7  0x08049f93 in strcpy ()
#8  0x4002f9d3 in __libc_start_main () from /lib/libc.so.6

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #155 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Zed Pobre <zed@resonant.org>, 165358@bugs.debian.org
Subject: Re: Bug#165358: apropos (from man-db) also apparently broken
Date: Mon, 28 Oct 2002 10:05:15 -0800
On Mon, Oct 28, 2002 at 11:39:32AM -0600, Zed Pobre wrote:

> erdos:~> gdb /usr/bin/apropos core
> gdb: Symbol `emacs_ctlx_keymap' has different size in shared object, consider re-linking

This is an odd error message.  Have you explored it at all?

-- 
When you get to the heart,
use a knife and fork.
 - Instructions for eating an artichoke.




Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #160 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: apropos (from man-db) also apparently broken
Date: Mon, 28 Oct 2002 12:51:45 -0600
[Message part 1 (text/plain, inline)]
On Mon, Oct 28, 2002 at 10:05:15AM -0800, Jeff Bailey wrote:
> On Mon, Oct 28, 2002 at 11:39:32AM -0600, Zed Pobre wrote:
> 
> > erdos:~> gdb /usr/bin/apropos core
> > gdb: Symbol `emacs_ctlx_keymap' has different size in shared object, consider re-linking
> 
> This is an odd error message.  Have you explored it at all?

    It happens on every gdb invocation, even on the system with the
older libc, so it's not related to the issue at hand more than
tangentially.  I've seen warnings like this from time to time over the
last few years -- they never seem to affect anything, and go away with
a simple recompilation.

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Zed Pobre <zed@resonant.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #165 received at 165358@bugs.debian.org (full text, mbox):

From: Zed Pobre <zed@resonant.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org
Subject: Re: Bug#165358: apropos (from man-db) also apparently broken
Date: Mon, 28 Oct 2002 12:58:42 -0600
[Message part 1 (text/plain, inline)]
I've discovered some interesting related behavior:  the segfault is at
least partially tied to the LANG*/LC_* environment variables.  With
the variables set to en_US, I get a segfault on pretty much every
apropos call, generally after the result is displayed.  With the
variables unset, most calls *don't* segfault, though if I "apropos
man" I'll still get a segfault after a display, and if I "apropos
amavisd" I get a segfault before anything is displayed at all.
Backtraces are the same.

-- 
Zed Pobre <zed@debian.org> a.k.a. Zed Pobre <zed@resonant.org>
PGP key and fingerprint available on finger; encrypted mail welcomed.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #170 received at 165358@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Jeff Bailey <jbailey@nisa.net>, 165358@bugs.debian.org
Cc: Zed Pobre <zed@resonant.org>
Subject: Re: Bug#165358: apropos (from man-db) also apparently broken
Date: Mon, 28 Oct 2002 14:09:18 -0500
On Mon, Oct 28, 2002 at 10:05:15AM -0800, Jeff Bailey wrote:
> On Mon, Oct 28, 2002 at 11:39:32AM -0600, Zed Pobre wrote:
> 
> > erdos:~> gdb /usr/bin/apropos core
> > gdb: Symbol `emacs_ctlx_keymap' has different size in shared object, consider re-linking
> 
> This is an odd error message.  Have you explored it at all?

It's a GDB bug.  I thought I'd fixed it already... maybe readline
changed under me again.

-- 
Daniel Jacobowitz
MontaVista Software                         Debian GNU/Linux Developer



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Joost Yervante Damad <joost@lumatec.be>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #175 received at 165358@bugs.debian.org (full text, mbox):

From: Joost Yervante Damad <joost@lumatec.be>
To: 165358@bugs.debian.org
Subject: workaround for __libc_fork and winex 2.0
Date: Tue, 29 Oct 2002 08:19:45 +0100
Hi,

if I add the following patch to the debian/patches dir
and the debian/patches/0list, winex 2.0 works fine for me
again:


#! /bin/sh -e

if [ $# -ne 2 ]; then
    echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
    exit 1
fi
case "$1" in
    -patch) patch -d "$2" -f --no-backup-if-mismatch -p0 < $0;;
    -unpatch) patch -d "$2" -f --no-backup-if-mismatch -R -p0 < $0;;
    *)
        echo >&2 "`basename $0`: script expects -patch|-unpatch as argument"
        exit 1
esac
exit 0

--- sysdeps/unix/sysv/linux/i386/Versions.orig       2002-10-25 20:52:36.000000000 +0200
+++ sysdeps/unix/sysv/linux/i386/Versions    2002-10-25 20:53:39.000000000 +0200
@@ -11,6 +11,9 @@
   }
   GLIBC_2.1 {
     modify_ldt;
   }
+  GLIBC_2.1.2 {
+    __libc_fork;
+  }
   GLIBC_2.2 {
     # functions used in other libraries
     __xstat64; __fxstat64; __lxstat64;


Greetings, Joost

-- 
openMSX: the MSX emulator that aims for perfection
         http://openmsx.sf.net/



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to GOTO Masanori <gotom@debian.or.jp>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #180 received at 165358@bugs.debian.org (full text, mbox):

From: GOTO Masanori <gotom@debian.or.jp>
To: Joost Yervante Damad <joost@lumatec.be>, 165358@bugs.debian.org
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: Sun, 03 Nov 2002 23:58:16 +0900
At Tue, 29 Oct 2002 08:19:45 +0100,
Joost Yervante Damad wrote:
> if I add the following patch to the debian/patches dir
> and the debian/patches/0list, winex 2.0 works fine for me
> again:

Thanks, this patch seems ok.

BTW, for debian glibc developer, redhat patch also moves this part to
posix/Versions.  We have 2 way to take action with this issue:

  (1) Applying this patch (with some modification), and we keep
      applying until after sarge is released.
  (2) Close and close these kind of bugs, just say "pleeeaaassee
      upgrade your broken jdk!".

I would like to take (1). Any comments?

-- GOTO "MSX lover" Masanori




Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #185 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: GOTO Masanori <gotom@debian.or.jp>
Cc: Joost Yervante Damad <joost@lumatec.be>, 165358@bugs.debian.org
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: 03 Nov 2002 18:25:59 -0500
[Message part 1 (text/plain, inline)]
On Sun, 2002-11-03 at 09:58, GOTO Masanori wrote:

> BTW, for debian glibc developer, redhat patch also moves this part to
> posix/Versions.  We have 2 way to take action with this issue:
> 
>   (1) Applying this patch (with some modification), and we keep
>       applying until after sarge is released.

I object to adding the patch - We cannot start a tradition of
compensating for broken software that uses hidden interfaces.  Apps are
going to hit this problem on all major arch's.  Certainly wine[x] is
working on a patch.  I believe all of the new JDKs out there work fine. 
Bigloo is the only other program we've had complaints for.

Tks,
Jeff Bailey

-- 
When you get to the heart,
use a knife and fork.
 - From instructions on how to eat an artichoke.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #190 received at 165358@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Jeff Bailey <jbailey@nisa.net>, 165358@bugs.debian.org
Cc: GOTO Masanori <gotom@debian.or.jp>, Joost Yervante Damad <joost@lumatec.be>
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: Sun, 3 Nov 2002 20:24:31 -0500
On Sun, Nov 03, 2002 at 06:25:59PM -0500, Jeff Bailey wrote:
> On Sun, 2002-11-03 at 09:58, GOTO Masanori wrote:
> 
> > BTW, for debian glibc developer, redhat patch also moves this part to
> > posix/Versions.  We have 2 way to take action with this issue:
> > 
> >   (1) Applying this patch (with some modification), and we keep
> >       applying until after sarge is released.
> 
> I object to adding the patch - We cannot start a tradition of
> compensating for broken software that uses hidden interfaces.  Apps are
> going to hit this problem on all major arch's.  Certainly wine[x] is
> working on a patch.  I believe all of the new JDKs out there work fine. 
> Bigloo is the only other program we've had complaints for.

I object to not adding the patch.  Just like our other compatibility
patches, these binaries are a fact of life; we should prevent exposing
the symbols at _link_ time, but there's no benefit to us in hiding them
at runtime.


-- 
Daniel Jacobowitz
MontaVista Software                         Debian GNU/Linux Developer



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #195 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: Daniel Jacobowitz <dan@debian.org>
Cc: 165358@bugs.debian.org, GOTO Masanori <gotom@debian.or.jp>, Joost Yervante Damad <joost@lumatec.be>
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: 03 Nov 2002 21:13:33 -0500
[Message part 1 (text/plain, inline)]
On Sun, 2002-11-03 at 20:24, Daniel Jacobowitz wrote:

> I object to not adding the patch.  Just like our other compatibility
> patches, these binaries are a fact of life; we should prevent exposing
> the symbols at _link_ time, but there's no benefit to us in hiding them
> at runtime.

The other compatibility patches are design to help programs that were
following the rules and that broke.  This patch is designed to help
programs that were badly written.  Will we be expected to maintain the
internal structures when they change, too?

In this particular case, we gain nothing by adding this patch (the
various upstream authors recognise that they shouldn't have used that
function and are patching their programs) - and simply postpone the fact
that people have to replace these programs.  Eventually the internal
interface will change - and it will probably just quietly segfault or
cause security problems instead of clearly saying that the program has
problems.

I think we should simply make sure that Sarge's release notes indicate
that certain commercial programs (Java, WineX) had been incorrectly
using the C library and may need to be upgraded to keep them running.  

Tks,
Jeff Bailey

-- 
When you get to the heart,
use a knife and fork.
 - From instructions on how to eat an artichoke.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #200 received at 165358@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: 165358@bugs.debian.org, GOTO Masanori <gotom@debian.or.jp>, Joost Yervante Damad <joost@lumatec.be>
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: Sun, 3 Nov 2002 22:09:39 -0500
On Sun, Nov 03, 2002 at 09:13:33PM -0500, Jeff Bailey wrote:
> On Sun, 2002-11-03 at 20:24, Daniel Jacobowitz wrote:
> 
> > I object to not adding the patch.  Just like our other compatibility
> > patches, these binaries are a fact of life; we should prevent exposing
> > the symbols at _link_ time, but there's no benefit to us in hiding them
> > at runtime.
> 
> The other compatibility patches are design to help programs that were
> following the rules and that broke.  This patch is designed to help
> programs that were badly written.  Will we be expected to maintain the
> internal structures when they change, too?
> 
> In this particular case, we gain nothing by adding this patch (the
> various upstream authors recognise that they shouldn't have used that
> function and are patching their programs) - and simply postpone the fact
> that people have to replace these programs.  Eventually the internal
> interface will change - and it will probably just quietly segfault or
> cause security problems instead of clearly saying that the program has
> problems.
> 
> I think we should simply make sure that Sarge's release notes indicate
> that certain commercial programs (Java, WineX) had been incorrectly
> using the C library and may need to be upgraded to keep them running.  

__libc_waitpid's hiding is not interface-related, it's
namespace-related.  There are no changing interfaces involved, and it's
clear that we can safely continue to export it unless there's a major
change.  __libc_fork similarly.  If we make the symbol unavailable at
link time - there's plenty of examples of this in glibc - then bad
binaries can no longer be built on Sarge; then a release later we can
stop supporting them.  I believe that the only fair thing for our users
is to allow a transition period.  This is the first release which
enforced the namespace rules; it was not very clearly documented
before.

-- 
Daniel Jacobowitz
MontaVista Software                         Debian GNU/Linux Developer



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to GOTO Masanori <gotom@debian.or.jp>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #205 received at 165358@bugs.debian.org (full text, mbox):

From: GOTO Masanori <gotom@debian.or.jp>
To: Daniel Jacobowitz <dan@debian.org>
Cc: Jeff Bailey <jbailey@nisa.net>, 165358@bugs.debian.org, GOTO Masanori <gotom@debian.or.jp>, Joost Yervante Damad <joost@lumatec.be>
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: Mon, 04 Nov 2002 21:01:53 +0900
At Sun, 3 Nov 2002 22:09:39 -0500,
Daniel Jacobowitz wrote:
> 
> On Sun, Nov 03, 2002 at 09:13:33PM -0500, Jeff Bailey wrote:
> > On Sun, 2002-11-03 at 20:24, Daniel Jacobowitz wrote:
> > I think we should simply make sure that Sarge's release notes indicate
> > that certain commercial programs (Java, WineX) had been incorrectly
> > using the C library and may need to be upgraded to keep them running.  
> 
> __libc_waitpid's hiding is not interface-related, it's
> namespace-related.  There are no changing interfaces involved, and it's
> clear that we can safely continue to export it unless there's a major
> change.  __libc_fork similarly.  If we make the symbol unavailable at
> link time - there's plenty of examples of this in glibc - then bad
> binaries can no longer be built on Sarge; then a release later we can
> stop supporting them.  I believe that the only fair thing for our users
> is to allow a transition period.  This is the first release which
> enforced the namespace rules; it was not very clearly documented
> before.

I agree, too.

We should take a transition period for many users. Some user read
sarge release notes, but other user does not read such a long
expressive documents. Some user can upgrade easily, but other user
cannot move to new JDK or such buggy software because of its own
circumstances.

Yes, we have to warn "for developer, you don't use such an internal
symbol", but from user point of view "I don't know such a export
issue, because I am a user". Sarge release documents only say some
commercial programs do not run after sarge, so we recommend to
upgrade such softwares.

In addition, the most important benefit is "we don't see this kind
of BTS" :-)
Jeff, would you reconsider it?

Regards,
-- GOTO "MSX1/2+ is the starting point of my computer experience" Masanori



Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Jeff Bailey <jbailey@nisa.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #210 received at 165358@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: GOTO Masanori <gotom@debian.or.jp>
Cc: Daniel Jacobowitz <dan@debian.org>, 165358@bugs.debian.org, Joost Yervante Damad <joost@lumatec.be>
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: 04 Nov 2002 07:38:39 -0500
[Message part 1 (text/plain, inline)]
On Mon, 2002-11-04 at 07:01, GOTO Masanori wrote:

> Yes, we have to warn "for developer, you don't use such an internal
> symbol", but from user point of view "I don't know such a export
> issue, because I am a user". Sarge release documents only say some
> commercial programs do not run after sarge, so we recommend to
> upgrade such softwares.

Then, is it possible to put a hack in the linker that prints an message
to STDERR or something?  Something really clear like "This package has
had a work around applied to it to make it run.  Please get a new
version.  It will break sometime in the future".

I mean, obviously the wording should be such that the user doesn't
panic.

> In addition, the most important benefit is "we don't see this kind
> of BTS" :-)

*lol*  True...

I want to make sure we're not dragging crap around from version to
version, and having to attempt to preserve this indefinetly.  Daniel
notes:

> __libc_waitpid's hiding is not interface-related, it's
> namespace-related.  There are no changing interfaces involved, and
it's
> clear that we can safely continue to export it unless there's a major
> change.

But I think that part of the hiding of the interface is that upstream is
free to change this interface at any time without notifying us.  Let's
say drepper changed it for 2.3.2.  (Note that I'm just about to run to
work, so I don't have time to look up what the actual interface is) 
Something subtle like changing the width of a parameter, or making it a
pointer instead of passing a value.  What we're proposing here is that
we will track those changes and compensate for them.  If we don't, some
upload sometime will start causing segfaults, or creating processes with
strange properties and do so subtly.  We'll then spend time chasing down
why "Upgrading to 2.x.y causes my JVM to segfault" when having it block
at load time could have solved the problem.

Perhaps the warning could also be changed to say "Symbol not found,
perhaps upgrade your program?" or something like that, with an
explanation of what the typical causes of that error message are?

Tks,
Jeff Bailey

-- 
When you get to the heart,
use a knife and fork.
 - From instructions on how to eat an artichoke.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org:
Bug#165358; Package libc6. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>, glibc@packages.qa.debian.org. Full text and rfc822 format available.

Message #215 received at 165358@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Jeff Bailey <jbailey@nisa.net>
Cc: GOTO Masanori <gotom@debian.or.jp>, 165358@bugs.debian.org, Joost Yervante Damad <joost@lumatec.be>
Subject: Re: Bug#165358: workaround for __libc_fork and winex 2.0
Date: Mon, 4 Nov 2002 09:15:17 -0500
On Mon, Nov 04, 2002 at 07:38:39AM -0500, Jeff Bailey wrote:
> On Mon, 2002-11-04 at 07:01, GOTO Masanori wrote:
> 
> > Yes, we have to warn "for developer, you don't use such an internal
> > symbol", but from user point of view "I don't know such a export
> > issue, because I am a user". Sarge release documents only say some
> > commercial programs do not run after sarge, so we recommend to
> > upgrade such softwares.
> 
> Then, is it possible to put a hack in the linker that prints an message
> to STDERR or something?  Something really clear like "This package has
> had a work around applied to it to make it run.  Please get a new
> version.  It will break sometime in the future".
> 
> I mean, obviously the wording should be such that the user doesn't
> panic.

At runtime?  No, and I don't think it's a particularly good idea -
redirecting output would break... and the check to print the warning
would be in the fast path of the runtime linker.

> > In addition, the most important benefit is "we don't see this kind
> > of BTS" :-)
> 
> *lol*  True...
> 
> I want to make sure we're not dragging crap around from version to
> version, and having to attempt to preserve this indefinetly.  Daniel
> notes:
> 
> > __libc_waitpid's hiding is not interface-related, it's
> > namespace-related.  There are no changing interfaces involved, and
> it's
> > clear that we can safely continue to export it unless there's a major
> > change.
> 
> But I think that part of the hiding of the interface is that upstream is
> free to change this interface at any time without notifying us.  Let's
> say drepper changed it for 2.3.2.  (Note that I'm just about to run to
> work, so I don't have time to look up what the actual interface is) 
> Something subtle like changing the width of a parameter, or making it a
> pointer instead of passing a value.  What we're proposing here is that
> we will track those changes and compensate for them.  If we don't, some
> upload sometime will start causing segfaults, or creating processes with
> strange properties and do so subtly.  We'll then spend time chasing down
> why "Upgrading to 2.x.y causes my JVM to segfault" when having it block
> at load time could have solved the problem.

The interface is simple: it's a strong alias to the exported waitpid()
function.  Similarly for fork.  It's there for libraries like
libpthread, which need to touch glibc internals in order to override
fork() etc.  That's not likely to change.

> Perhaps the warning could also be changed to say "Symbol not found,
> perhaps upgrade your program?" or something like that, with an
> explanation of what the typical causes of that error message are?

Hmm...

-- 
Daniel Jacobowitz
MontaVista Software                         Debian GNU/Linux Developer



Reply sent to Jeff Bailey <jbailey@nisa.net>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Rene Engelhard <rene@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #220 received at 165358-close@bugs.debian.org (full text, mbox):

From: Jeff Bailey <jbailey@nisa.net>
To: 165358-close@bugs.debian.org
Subject: Bug#165358: fixed in glibc 2.3.1-6
Date: Sat, 21 Dec 2002 05:03:00 -0500
We believe that the bug you reported is fixed in the latest version of
glibc, which is due to be installed in the Debian FTP archive:

glibc-doc_2.3.1-6_all.deb
  to pool/main/g/glibc/glibc-doc_2.3.1-6_all.deb
glibc_2.3.1-6.diff.gz
  to pool/main/g/glibc/glibc_2.3.1-6.diff.gz
glibc_2.3.1-6.dsc
  to pool/main/g/glibc/glibc_2.3.1-6.dsc
libc-udeb_2.3.1-6_i386.udeb
  to pool/main/g/glibc/libc-udeb_2.3.1-6_i386.udeb
libc6-dbg_2.3.1-6_i386.deb
  to pool/main/g/glibc/libc6-dbg_2.3.1-6_i386.deb
libc6-dev_2.3.1-6_i386.deb
  to pool/main/g/glibc/libc6-dev_2.3.1-6_i386.deb
libc6-pic_2.3.1-6_i386.deb
  to pool/main/g/glibc/libc6-pic_2.3.1-6_i386.deb
libc6-prof_2.3.1-6_i386.deb
  to pool/main/g/glibc/libc6-prof_2.3.1-6_i386.deb
libc6_2.3.1-6_i386.deb
  to pool/main/g/glibc/libc6_2.3.1-6_i386.deb
locales_2.3.1-6_all.deb
  to pool/main/g/glibc/locales_2.3.1-6_all.deb
nscd_2.3.1-6_i386.deb
  to pool/main/g/glibc/nscd_2.3.1-6_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 165358@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Jeff Bailey <jbailey@nisa.net> (supplier of updated glibc package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Fri, 20 Dec 2002 20:19:24 -0500
Source: glibc
Binary: libc6.1-prof libc1 libc0.3-pic locales glibc-doc libc6-pic libc-udeb libc1-prof libc0.3 libc0.3-dbg libc6.1-dev libc1-pic libc6-s390x libc6-prof libc1-dbg libc6-dev-sparc64 libc6 libc0.3-dev libc6-dbg nscd libc6.1-dbg libc6.1-pic libc6-sparc64 libc6-dev libc0.3-prof libc6.1 libc6-dev-s390x libc1-dev
Architecture: source i386 all
Version: 2.3.1-6
Distribution: unstable
Urgency: low
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Changed-By: Jeff Bailey <jbailey@nisa.net>
Description: 
 glibc-doc  - GNU C Library: Documentation
 libc-udeb  - GNU C Library: Shared libraries and Timezone data - udeb (udeb)
 libc6      - GNU C Library: Shared libraries and Timezone data
 libc6-dbg  - GNU C Library: Libraries with debugging symbols
 libc6-dev  - GNU C Library: Development Libraries and Header Files.
 libc6-pic  - GNU C Library: PIC archive library
 libc6-prof - GNU C Library: Profiling Libraries.
 locales    - GNU C Library: National Language (locale) data [support]
 nscd       - GNU C Library: Name Service Cache Daemon
Closes: 151784 154244 156386 164523 165358 165603 169919 170385 170507 171451 171550 171804 173201
Changes: 
 glibc (2.3.1-6) unstable; urgency=low
 .
   * The "I will not be thwarted" release.
 .
   * Daniel Jacobowitz <dan@debian.org>
     - Update glibc23-ctype-compat.patch to fix segfaults in old static
       binaries (Closes: #171451).
     - Allow building from the CVS checkout without getting CVS dirs in the
       resulting packages.  Whew.
 .
   * Jeff Bailey <jbailey@nisa.net>
     - debian/patches/cvs.dpatch: Update.
       (Closes: #171550, #170507)
     - debian/patches/0list: Update
     - debian/control.in/libc: Conflict against wine (<< 0.0.20021007-1)
       (Closes: #170385)
       Also conflict against php4 (<< 4:4.2.3-5)
       Thanks to Steve Langasek for hunting this down!
     - debian/rules: Disable sparc64 build targets for now.
     - debian/packages.d/s390x.mx: Setup the 64 bit build as a cross-compile,
       because 's390' cannot run binaries intended for 's390x'
 .
   * GOTO Masanori <gotom@debian.or.jp>
     - cvs.dpatch update resolve some bugs (Closes: #169919, #165603)
     - debian/patches/glibc23-hppa-Rminkernel.dpatch: Added hppa kernel
       version checking due to prevent people from installing unmatched version.
       Patched by Carlos O'Donell (Closes: #171804)
     - debian/libc/DEBIAN/preinst: likewise.
     - glibc23-function-compat.dpatch: Added for some bad application to
       keep running and not to resolve some symbols like __libc_wait,
       __libc_waitpid, so on. This patch will be removed when sarge will be
       relased apparently. (Closes: #165358, #173201)
 .
     - debian/locales/DEBIAN/config: db_set is set if and only if locale.gen
       is existed.  Patched by Masato Taruishi <taru@debian.org>
       His note:
        The previous config script always set locales_to_be_generated
        even when /etc/locale.gen doesn't exist. So the question in
        dpkg-preconfigure time became empty in dpkg --configure locales time.
        This change resolves long outstanding locales bug.
       (Closes: #156386, #151784, #154244, #164523)
Files: 
 25e7b44821cc29e548bde35f660cf3a3 1523 libs required glibc_2.3.1-6.dsc
 a2e8886b35c81ae49e50f2c3a14ab195 1808921 libs required glibc_2.3.1-6.diff.gz
 bdb7870dc7e68fc311b4e909c861264c 3191026 base required libc6_2.3.1-6_i386.deb
 5ebe3058f2bb39f1976f38c18938472c 516008 debian-installer required libc-udeb_2.3.1-6_i386.udeb
 74155f0ddc9c2bea9e540e1d7cb9084e 2386682 devel standard libc6-dev_2.3.1-6_i386.deb
 74cb9c633284350298259704f17943ae 889004 devel extra libc6-prof_2.3.1-6_i386.deb
 1d55e54d84d40245b9068d1f08916aa8 5286474 devel extra libc6-dbg_2.3.1-6_i386.deb
 2d5864584789034febd98569e9f6cc60 840770 devel optional libc6-pic_2.3.1-6_i386.deb
 0868eb8b1c3e70285ec883604617632d 63674 admin optional nscd_2.3.1-6_i386.deb
 5510bbd029c3b04e21f36c2aca12b6f5 3741954 base standard locales_2.3.1-6_all.deb
 1ddfa90f4c0f5c282ad099c75418299b 2980526 doc optional glibc-doc_2.3.1-6_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.1 (GNU/Linux)

iD8DBQE+BDLM5M5hmdCYCpkRAmmJAJ4hmzu6S4EIHwcgJF4P0qWqrV24dgCdH80z
r7n7bZl9ztDcgvvVw9QBaIQ=
=Vvxe
-----END PGP SIGNATURE-----




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 10:54:04 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.